#include <bits/stdc++.h>
using namespace std;
    string a, b;
    vector <pair<long long, long long> > er;
    long long n, m, p;
    pair<long long, long long> A[100000];
int main (){
ios_base::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
    long long i, j;
    cin >> a;
    n=a.length();
    cin >> m;
    for (i=0; i<m; i++){
        cin >> b;
        p=a.find(b);
        while (p!=string::npos){
            er.push_back(make_pair(p, b.size()));
//            a.erase(p, b.size());
            p=a.find(b, p+b.size());
        }
    }
    n=er.size();
    for (i=0; i<n; i++){
        A[i].first=er[i].first;
        A[i].second=er[i].second;
    }
    sort(A, A+n);
    long long l=0;
    for (i=0; i<n; i++){
        a.erase(A[i].first-l, A[i].second);
        l+=A[i].second;
    }
    cout << a << endl;
return 0;
}
